% LemkeHowson Solves mixed strategies for bimatrix game.
%   [p,q,err]=LemkeHowson(A,B);
% ERR returns an error condition:
%   0: Solution found
%   1: Maximum iterations exceeded

function [p,q,r,s] = LemkeHowson(U1,U2)
%err=0;
k0=1;
%MAX=100;
[m n]=size(U1);
P=[U2',eye(n),ones(n,1)];
Q=[eye(m),U1,ones(m,1)];
k=k0;
clq=1:m;
clp=m+1:m+n;

while 1
    [P k clp]=pivot(P,k,clp);
    if(k==k0)
        break;
    end
    [Q k clq]=pivot(Q,k,clq);
    if(k==k0)
        break;
    end
end

p=zeros(m,1);
q=zeros(n,1);
r=zeros(m,1);
s=zeros(n,1);
for i=1:n
    k=clp(i);
    if k<=m
        p(k)=P(i,m+n+1)/P(i,k);
    else
        s(k-m)=P(i,m+n+1)/P(i,k);
    end
end

for i=1:m
    k=clq(i);
    if k<=m
        r(k)=Q(i,m+n+1)/Q(i,k);
    else
        q(k-m)=Q(i,m+n+1)/Q(i,k);
    end
end
cb=1/sum(p);
ca=1/sum(q);
p=cb*p;
q=ca*q;
r=ca*r;
s=cb*s;
end
